﻿Imports System.IO.Ports

Public Class Form1

    Dim sb, sb2 As New System.Text.StringBuilder
    Dim buffer() As Byte

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load

        Me.Text = My.Application.Info.AssemblyName

        Try
            SerialPort1.BaudRate = My.Settings.baudrate
        Catch ex As Exception
            SerialPort1.BaudRate = 115200
            My.Settings.baudrate = SerialPort1.BaudRate
            My.Settings.Save()
        End Try

        SerialPort1.DataBits = 8
        SerialPort1.StopBits = 1
        SerialPort1.Handshake = IO.Ports.Handshake.None

        scan()

    End Sub

    Private Sub SerialPort1_DataReceived(sender As Object, e As SerialDataReceivedEventArgs) Handles SerialPort1.DataReceived

        sb.Append(SerialPort1.ReadExisting)

    End Sub

    Private Sub OpenOBJToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles OpenOBJToolStripMenuItem.Click

        Dim dr As DialogResult

        OpenFileDialog1.Filter = "Object files (*.obj)|*.obj"
        dr = OpenFileDialog1.ShowDialog
        If dr = DialogResult.Cancel Then Exit Sub

        buffer = IO.File.ReadAllBytes(OpenFileDialog1.FileName)

        build_hex()
        RichTextBox2.Text = sb2.ToString

    End Sub

    Public Sub build_hex()

        Dim m As String
        Dim z As Integer

        sb2.Clear()

        sb2.Append("> Prop_Hex 0 0 0 0 " + vbCrLf)
        For a = 0 To buffer.Length - 1
            m = Hex(buffer(a))
            m = " " + m
            sb2.Append(m)
            z += 1
        Next
        sb2.Append("~")

    End Sub

    Public Sub prop_reset()

        If SerialPort1.IsOpen Then
            SerialPort1.DtrEnable = True
            SerialPort1.DtrEnable = False
            Threading.Thread.Sleep(100)
        End If

    End Sub

    Private Sub OpenOBJCreateTXTToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles OpenOBJCreateTXTToolStripMenuItem.Click

        Dim dr As DialogResult
        Dim m As String
        Dim ic As Integer

        m = InputBox("Frequency of " + Chr(34) + ">" + Chr(34) + "insertion into stream", "Atobaud sync", 511)
        If m = "" Then
            ic = 0
        Else
            Try
                ic = Val(m)
            Catch ex As Exception
                ic = 0
            End Try
        End If


        OpenFileDialog1.Filter = "Object files (*.obj)|*.obj"
        dr = OpenFileDialog1.ShowDialog
        If dr = DialogResult.Cancel Then Exit Sub

        buffer = IO.File.ReadAllBytes(OpenFileDialog1.FileName)

        build_txt(ic)
        RichTextBox2.Text = sb2.ToString

        m = "OBJ file size = " + buffer.Length.ToString + vbCrLf
        m &= "Txt output size = " + Len(sb2.ToString).ToString + vbCrLf

        MessageBox.Show(m)

    End Sub


    Private Sub p2_search_Click(sender As Object, e As EventArgs) Handles p2_search.Click

        scan()

    End Sub

    Public Sub scan()

        Dim m As String
        Dim m2 As String = Nothing
        Dim id As String

        CheckedListBox1.Items.Clear()

        For Each s As String In IO.Ports.SerialPort.GetPortNames
            SerialPort1.PortName = s
            Try
                SerialPort1.Open()
            Catch ex As Exception
                MessageBox.Show(ex.Message)
            End Try
            prop_reset()
            sb.Clear()
            If SerialPort1.IsOpen Then SerialPort1.Write("> Prop_Chk 0 0 0 0 ")
            Threading.Thread.Sleep(100)
            m = sb.ToString
            m = Mid(m, 3, 11)
            m = Trim(m)
            m2 &= s + " = "
            Select Case m
                Case "Prop_Ver Au"
                    id = "[Au] Parallax P123_A9" + vbCrLf
                    m2 &= id
                    CheckedListBox1.Items.Add(s + ": " + id)
                Case "Prop_Ver Bu"
                    id = "[Bu] Terasic DE2-115" + vbCrLf
                    m2 &= id
                    CheckedListBox1.Items.Add(s + ": " + id)
                Case "Prop_Ver Cu"
                    id = "[Cu] Terasic DE0-Nano" + vbCrLf
                    m2 &= id
                    CheckedListBox1.Items.Add(s + ": " + id)
                Case "Prop_Ver Du"
                    id = "[Du] BeMicro CV-A2" + vbCrLf
                    m2 &= id
                    CheckedListBox1.Items.Add(s + ": " + id)
                Case "Prop_Ver Eu"
                    id = "[Eu] Parallax P123_A7" + vbCrLf
                    m2 &= id
                    CheckedListBox1.Items.Add(s + ": " + id)

                Case Else
                    m2 &= m + vbCrLf
            End Select


            If SerialPort1.IsOpen Then SerialPort1.Close()

        Next

        If m2 = "" Then m2 = "No P2's detected"
        MessageBox.Show(m2, "P2 FPGA search results", MessageBoxButtons.OK, MessageBoxIcon.Information)

    End Sub

    Private Sub send_Click(sender As Object, e As EventArgs) Handles send.Click

        Dim m, m2 As String
        Dim z As Integer


        m2 = "Txt output size = " + sb2.Length.ToString + vbCrLf

        If CheckedListBox1.CheckedItems.Count = 0 Then
            MessageBox.Show("No target(s) selected", "Send failed", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Exit Sub
        End If

        For t = 0 To CheckedListBox1.CheckedItems.Count - 1
            z = InStr(CheckedListBox1.CheckedItems(t), ":")
            m = Mid(CheckedListBox1.CheckedItems(t), 1, z - 1)
            SerialPort1.PortName = m
            m2 &= m + vbCrLf
            Try
                SerialPort1.Open()
            Catch ex As Exception
                MessageBox.Show(ex.Message, "Problem", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Exit Sub
            End Try


            prop_reset()
            If SerialPort1.IsOpen Then
                SerialPort1.Write(sb2.ToString)
                SerialPort1.Close()
            End If
            'sw.Stop()

        Next t

        MessageBox.Show(m2)

    End Sub


    Private Sub SetBaudrateToolStripMenuItem1_Click(sender As Object, e As EventArgs) Handles SetBaudrateToolStripMenuItem1.Click

        Dim m As String
        Dim tb As Integer

        tb = SerialPort1.BaudRate

        m = InputBox("Enter baudrate (1200 to 2M", "Set Baudrate", My.Settings.baudrate.ToString)
        If m = "" Then Exit Sub

        Try
            SerialPort1.BaudRate = Val(m)
        Catch ex As Exception
            MessageBox.Show(ex.Message)
            SerialPort1.BaudRate = tb
            Exit Sub
        End Try

        My.Settings.baudrate = Val(m)
        My.Settings.Save()


    End Sub

    Private Sub reset_p2_Click(sender As Object, e As EventArgs) Handles reset_p2.Click

        Dim m As String
        Dim z As Integer

        If CheckedListBox1.CheckedItems.Count = 0 Then
            MessageBox.Show("No target(s) selected")
            Exit Sub
        End If

        For t = 0 To CheckedListBox1.CheckedItems.Count - 1
            z = InStr(CheckedListBox1.CheckedItems(t), ":")
            m = Mid(CheckedListBox1.CheckedItems(t), 1, z - 1)
            SerialPort1.PortName = m
            Try
                SerialPort1.Open()
            Catch ex As Exception
                MessageBox.Show(ex.Message)
                Exit For

            End Try
            prop_reset()
            If SerialPort1.IsOpen Then SerialPort1.Close()

        Next

    End Sub

    Private Sub SaveToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles SaveToolStripMenuItem.Click

        Dim dr As DialogResult

        SaveFileDialog1.Filter = "Text files (*.txt)|*.txt"
        SaveFileDialog1.DefaultExt = "txt"
        dr = SaveFileDialog1.ShowDialog
        If dr = DialogResult.Cancel Then Exit Sub

        FileOpen(1, SaveFileDialog1.FileName, OpenMode.Output)
        Print(1, sb2.ToString)
        FileClose()

        MessageBox.Show(SaveFileDialog1.FileName + " saved")

    End Sub

    Private Sub ExitToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles ExitToolStripMenuItem.Click

        End

    End Sub

    Public Sub build_txt(ic As Integer)

        Dim mysize As Integer
        Dim idx As Integer
        Dim mybyte As Integer
        Dim out6 As Integer
        Dim mask As Integer
        Dim blip As Integer


        idx = 0
        mysize = 0
        mybyte = 0

        sb2.Clear()
        sb2.Append("> Prop_Txt 0 0 0 0 " + vbCrLf)
        Do
            If mysize < 6 Then
                mysize += 8
                mybyte <<= 8
                mybyte += buffer(idx)
                idx += 1
            End If

            out6 = mybyte >> (mysize - 6)   'get top 6 bits
            Select Case out6
                Case 0 To &H19
                    sb2.Append(Chr(Asc("A") + out6))
                Case &H1A To &H33
                    sb2.Append(Chr(Asc("a") + (out6 - &H1A)))
                Case &H34 To &H3D
                    sb2.Append(Chr(Asc("0") + (out6 - &H34)))
                Case &H3E
                    sb2.Append("+")
                Case &H3F
                    sb2.Append("/")
            End Select

            If ic Then blip += 1
            If blip = ic And ic <> 0 Then
                blip = 0
                sb2.Append(">")
            End If

            mysize -= 6
            mask = (2 ^ mysize) - 1
            mybyte = mybyte And mask

        Loop While idx < buffer.Length - 1

        sb2.Append(" ~")
    End Sub

End Class
